#pragma once

#include "../gui/GuiComponent.hpp"
#include "../Sorter.hpp"
#include <raylibs/raygui.h>
#include <string>
#include "../gui/CoreComponents.hpp"

class BigSortComponent : public sva::GuiComponent
{
	Vector2 m_ComponentOffset = { 0,0 };

	// BigSortComponent: controls initialization
	//----------------------------------------------------------------------------------
	Vector2 anchor01 = { 8, 8 };
	Vector2 anchor02 = { 224, 24 };
	Vector2 anchor03 = { 160, 152 };

	bool m_FunctionDropdown_EditMode = false;
	int m_FunctionDropdown_Active = 0;

	bool m_FunctionTextBox_EditMode = false;
	char m_FunctionTextBox_Text[256] = "Name own Function";

	sva::ErrorWindow m_ErrorWindow;

	//----------------------------------------------------------------------------------
public:
	BigSortComponent();

	int draw() override;
	int input() override;
	void onAttach() override;

private:
	sol::state m_LuaState;

	std::vector<std::string> m_FunctionNames;
	std::string m_FunctionList;

	sva::Sorter m_Sorter;
	std::vector<sva::Sorter::SortResult> m_SortResults;
	sva::Sorter::SortResult* m_ActiveSortResult = nullptr;

	void run_test();
	void add_function(const std::string&);
	void repack_function_list();
};